package myrobot;

import userfunctions.*;
import jess.*;


/**
 * External function:
 * (atan2 <y> <x>) where <value> is expressed in degrees
 */

public class Atan2 implements Userfunction {

    public String getName() {
        return "atan2";
    }

    public Value call(ValueVector vv, Context context) throws JessException {
        int y = (int) vv.get(1).numericValue(context);
        int x = (int) vv.get(2).numericValue(context);

        // Perform radians2degrees conversion
        return new Value(Math.atan2(y,x)*180/Math.PI, RU.FLOAT);
    }
}
