;;(watch facts)
;;(watch rules)

;;***************************************
;;*******PROTOTIPO GAOGAIGAR v 1.0*******
;;******   COPYRIGHTS BY SUNRISE   ******
;;***************************************
;;*ALESSANDRO GAGGIA & DARIO DELLA RATTA*
;;***************************************

;;********   VARIABILI GLOBALI   ********
(defglobal 

	?*DIST_POW2* = 250				;;DISTANZA SPARO POTENZA 2
	?*DIST_POW3* = 130				;;DISTANZA SPARO POTENZA 3
	?*DIST_BUSTER* = 80				;;DISTANZA SPARO POTENZA 5

)

;;************* TEMPLATES ***************
;;***DEFINISCONO L'INSIEME DI SLOT PER***
;;**IL PROPRIO ROBOT E PER L'AVVERSARIO**
;;***************************************

;********** GAOGAIGAR TEMPLATE **********

(deftemplate Gaogaigar_state
	(slot follow)					;;CONTIENE IL NOME DELL'OBBIETTIVO
	(slot power)					;;VIENE UTILIZZATO DALLA FORMULA DI TESSERA PER CALCOLARE IL VALORE INIZIALE DEL DT PER 
)								;;CALCOLARE LA X E LA Y DEL NEMICO IN BASE ALLA SUA VELOCITA' (VEDI REGOLA AIM-GUN)

;*********** ZONDAR TEMPLATE ************

(deftemplate Zondar_Metal
	(slot name)
	(slot x)
	(slot y)
	(slot distance)
	(slot velocity)
	(slot heading)
	(slot energy)
	(slot time)
	(slot bearing)
)

;;****** REGOLE SUDDIVISE IN TASK *******
;;************ TASK STARTUP *************
;;***************************************

(defrule Yuusha_Oh_Tanjou 
	(task startup)					;;VEDI REGOLE CON SALIENCE (-100). SI APPLICANO DI 
								;;VOLTA IN VOLTA QUANDO LE ALTRE SONO GIA'STATE APPLICATE
	=>
	
	(printout t "FINAL FUSIOOON!" crlf)
	
	(store AdjustGunForRobotTurn true)		;;ATTIVIAMO LE VARIABILI PER MUOVERE LE TRE PARTI 	
	(store AdjustRadarForRobotTurn true)	;;DEL CARRO ARMATO IN MANIERA INDIPENDENTE
	(store AdjustRadarForGunTurn true)
	(assert	(Gaogaigar_state			;;INIZIALIZZAZIONE STATO
			(follow no)
			(power 1)
		)
	)
	(assert (move ahead))				;;DEFINIZIONE DI UN FATTO AHEAD (SERVE PER GLI HITROBOTEVENT)
)

;;************ TASK EVALUATE ************
;;***************************************

(defrule new-Zondar					;;SE RILEVO UN NEMICO ASSERISCO UN NUOVO FATTO NEMICO
	(task evaluate)					;;E CON UNA SEMPLICE TRIANGOLAZIONE USANDO DISTANZA, IL NOSTRO HEADING E IL
	(Time ?time)					;;BEARING DELL' AVVERSARIO CALCOLIAMO LE SUE COORDINATE ATTUALI
	(ScannedRobotEvent
		(Name ?name)
		(Energy ?energy)
		(Distance ?distance)
		(Heading ?heading)
		(Velocity ?velocity)
		(Bearing ?bearing)
	)
	(X ?myX)						;;DATI DEL NOSTRO CARRO ARMATO
	(Y ?myY)
	(Heading ?myHead)
	=>
	(assert (Zondar_Metal
			(name ?name)
			(energy ?energy)
			(x (enemyX ?myX ?distance ?bearing ?myHead))	;;SI RICHIAMANO LE FUNZIONI PER CALCOLARE X e Y
			(y (enemyY ?myY ?distance ?bearing ?myHead))	;;VEDI IN FONDO AL CODICE
			(bearing ?bearing)
			(distance ?distance)
			(heading ?heading)
			(velocity ?velocity)
			(time ?time)
		)
	)
	(printout t "NEW ZONDAR METAL DETECTED: " ?name crlf)
)

(defrule refresh_Zondar_signal
	(task evaluate)
	(Time ?time)
	(ScannedRobotEvent
		(Name ?name)
		(Energy ?energy)
		(Distance ?distance)
		(Heading ?heading)
		(Velocity ?velocity)
		(Bearing ?bearing)
	)
	?enemy	<-(Zondar_Metal 			;;SE IL NEMICO INDIVIDUATO DAL RADAR E' LO STESSO DI UN FATTO ZONDAR_METAL (NEMICO)
			(name ?name)			;;GIA' INDIVIDUATO (?name UGUALE PER ENTRAMBI) MA IN UN TEMPO DIFFERENTE, MODIFICHIAMO
			(time ~?time)			;;IL FATTO PER AGGIORNARE LE COORDINATE CORRENTI DEL NEMICO
		   )
	(X ?myX)
	(Y ?myY)
	(Heading ?myHead)
	
	=>
	
	(modify ?enemy 
		(energy ?energy)
		(x (enemyX ?myX ?distance ?bearing ?myHead))	;;MODIFICHIAMO LE COORDINATE IN MODO DA MANTENERE LA "MAPPA"
		(y (enemyY ?myY ?distance ?bearing ?myHead))	;;DEI NOSTRI AVVERSARI SEMPRE COERENTE
		(bearing ?bearing)
		(distance ?distance)
		(heading ?heading)
		(velocity ?velocity)
		(time ?time)
	)
	(printout t "SAME ZONDAR AS ALWAYS: " ?name "KEEP GOING GAI!" crlf)
)

(defrule delete-death-people
	(task evaluate)
	(RobotDeathEvent
		(Name ?name)
	)
	?enemy	<-(Zondar_Metal (name ?name))		;;QUANDO MUORE UN AVVERSARIO SE FA PARTE DEI FATTI AVVERSARIO 
	=>								;;QUESTO VIENE RITRATTATO
	(retract ?enemy)
	(printout t "HIKARI NI NARAAAAA!!!" crlf)
)

(defrule winning-is-all-that-matters
	(task evaluate)
	(WinEvent)
	=>
	(printout t "VICTORY GOES TO THOSE WHO HAVE GUTS!" crlf)
)

;;************* TASK THINK **************
;;***************************************

(defrule select-objective
	(task think)
	
	?state	<- (Gaogaigar_state (follow ?follow))		;;REGOLA PER LA SELEZIONE DELL'AVVERSARIO
											;;SE UN AVVERSARIO NON E' L'OBBIETTIVO CORRENTE
	(Zondar_Metal (name ?name1&~?follow)				;;E NESSUN ALTRO HA UNA DISTANZA MINORE LO SI SCEGLIE COME
		      (distance ?dist1)						;;NUOVO OBBIETTIVO (nota: SICCOME POSSONO ESSERCI PIU' MONDI
	)										;;POSSIBILI IN CUI QUESTO SI VERIFICA CIOE' PIU' DI UN SOLO 
	(not	(Zondar_Metal (name ?name2)					;;FATTO AVVERSARIO CHE VERIFICA QUESTA CONDIZIONE LA SCELTA DELL'
			      (distance ?dist2&:(< ?dist2 ?dist1))	;;OBBIETTIVO DIPENDERA' ANCHE DA QUALE ISTANZA DELLA REGOLA VERRA'
		)									;;ATTIVATA (Fire) PER PRIMA
	)
	
	=>
	
	(modify ?state (follow ?name1)
		       
	)	
)

(defrule hit_my_fault_going_backward (declare (salience 100))
	
	(task think)
	
	?direz <- (move ahead)							;;SE STIAMO ANDANDO AVANTI E
	?event <- (HitRobotEvent)						;;AVVIENE UNA COLLISIONE ANDIAMO INDIETRO
											;;RITRATTANDO AVANTI E ASSERENDO UN FATTO INDIETRO
	=>										;;nota: REGOLA MOLTO SEMPLICE NON COPRE TUTTE LE CAUSE
	(store Back 100)								;;DI HIT E NON E' DETTO CHE IN PRATICA FUNZIONI SEMPRE
	(retract ?event)								;;PERO' E' LEGGERA E NON HA BISOGNO DI TROPPE CONDIZIONI
	(retract ?direz)
	(assert (move back))
)

(defrule hit_my_fault_going_forward (declare (salience 100))
	
	(task think)								;;STESSA REGOLA MA PER LA SITUAZIONE DUALE
	
	?direz <- (move back)
	?event <- (HitRobotEvent)
		
	=>
	(store Ahead 100)
	(retract ?event)
	(retract ?direz)
	(assert (move ahead))
)

(defrule keep_away (declare (salience 100))	
	(task think)
	?event <- (ScannedRobotEvent (Distance ?distanza&:(< ?distanza 50)))
	?direz <- (move ?move)
	(not (HitWallEvent))
	(Heading ?my_head)							;;SE UN NEMICO QUALSIASI NEL MOMENTO IN CUI E' 
	=> 										;;RILEVATO STA A MENO DI 50 PIXEL CAMBIO DIREZIONE
	(retract ?event)								;;DI 180
	(store TurnLeft (+ 180 ?my_head))					;;SEMPLICE SCHIVATA GENERICA, DA UNA PARVENZA DI RANDOM
      (store Ahead 50)								;;AL MOVIMENTO ED E' POSSIBILE GRAZIE AL FATTO CHE LA TORRETTA
      (retract ?direz)								;;MIRA INDIPENDENTEMENTE DAL MOVIMENTO
	(assert (move ahead))
        
)

;;************** TASK ACT ***************
;;***************************************

(defrule scan-all-around					;;SCANSIONE A 360 GRADI GRAZIE AL MOVIMENTO INDIPENDENTE
	(task act)							;;CHE NON CREA PROBLEMI
	=>
	(store TurnRadarLeft 360)
	(printout t "SCANNING FOR ZONDARS..." crlf)
)


(defrule aim-gun
	(task act)
	(GunHeading ?gunHead)
	(Time ?time)
	(X ?x)
	(Y ?y)
	(Gaogaigar_state
		(follow ?name)
		(power ?power)
	)
	(Zondar_Metal
		(name ?name)
		(x ?enemyX)
		(y ?enemyY)
		(distance ?distance)					;;REGOLA PER IL PUNTAMENTO FA USO DI TUTTE LE FUNZIONI DI TESSERA ROBERTO.
		(velocity ?enemyVel)					;;SI PRENDE IL TEMPO ATTUALE (Time ?time) QUELLO DELL'OBBIETTIVO (?timeLast)
		(heading ?enemyHead)					;;E DOPO AVER INIZIALIZZATO DT, AVENDO LA VELOCITA' DEL NEMICO SI CALCOLANO
		(time ?timeLast)						;;X E Y DEL NEMICO COME S = V*DT (UTILIZZANDO OVVIAMENTE ANCHE L'HEADING 
	)									;;DEL NEMICO) QUINDI SI OTTENGONO I DX E DY (CATETI DELLA
	=>									;;DISTANZA TRA NOI E IL NEMICO) QUINDI L'ANGOLO DI TIRO COME ARCOTANGENTE DI DY/DX
	(bind ?dt (/ ?distance (- 20 (* ?power 3))))		;;INFINE LO SI NORMALIZZA PER RUOTARE LA TORRETTA
	(bind ?px (predictX ?enemyX ?enemyVel ?enemyHead (+ ?dt ?time) ?timeLast))
	(bind ?py (predictY ?enemyY ?enemyVel ?enemyHead (+ ?dt ?time) ?timeLast))
	(bind ?dx (- ?px ?x))
	(bind ?dy (- ?py ?y))
	(bind ?alpha (atan2 ?dy ?dx))
	(bind ?beta  (normalize (- 90 (+ ?alpha ?gunHead))))
	(store TurnGunRight ?beta)
)



(defrule hit-wall (declare (salience 100))
	(task act)
	?event<-(HitWallEvent
					(Bearing ?bear)		;;SE SBATTO CONTRO UN MURO CAMBIO DIREZIONE RISPETTO ALL'ANGOLO DI 
			)						;;IMPATTO
	=>
	(store TurnLeft (- 180 ?bear))
	(retract ?event)
)

(defrule slide_on_enemy_1 (declare (salience 100))
	(task act)
	(ScannedRobotEvent (Distance ?distance&:(< ?distance 50)))
	=>
	(store Back 100)
	(store Turnleft 120)
)											;;UN PO' DI MOVIMENTI RANDOM FORZATI DALLA PRESENZA DI QUALCHE AVVERSARIO

(defrule slide_on_enemy_2 (declare (salience 100))
	(task act)
	(ScannedRobotEvent (Distance ?distance&:(> ?distance 300))
	)	
	=>
	(store Ahead 100)
	(store TurnLeft 60)
)


;;************* TASK ACT_2 **************
;;***************************************

(defrule moving_around
	(task act)
?event<-(Gaogaigar_state
		(follow ?name)				
	)
	(Zondar_Metal
		(name ?name)
		(distance ?distance&:(> ?distance ?*DIST_POW2*))		;;AVVICINARSI ALL'OBBIETTIVO SE E' TROPPO LONTANO
		(bearing ?enemyHead)
	)
	(not(Zondar_Metal
			(name ?name1&~?name)
			(distance ?dist1&:(< ?dist1 ?distance))
	))
	=>
	(store TurnRight ?enemyHead)
	(store Ahead 80)
)
;;*******COLPO A BASSA POTENZA********
(defrule broken_magnum
	(task act2)
	
	(Zondar_Metal
			(name ?name)
			(distance ?distance&:(< ?distance ?*DIST_POW2*)&:(> ?distance ?*DIST_POW3*))
	)
	(Gaogaigar_state (follow ?name)
		         
	)
	
	=>
		
	(store Fire 2)
	(store TurnLeft 50)
	(store Back 5000)	
)

;;*******COLPO A MEDIA POTENZA********
(defrule broken_phantom
	(task act2)
	
	(Zondar_Metal
			(name ?name)
			(distance ?distance&:(< ?distance ?*DIST_POW3*)&:(> ?distance ?*DIST_BUSTER*))
	)
	(Gaogaigar_state (follow ?name)
		         
	)
	
	=>
		
	(store Fire 3)
	(store TurnLeft 50)
	(store Back 5000)	
)

;;*******COLPO A MASSIMA POTENZA********
(defrule goldion_hammer
	(task act2)
	
	(Zondar_Metal
			(name ?name)
			(distance ?distance&:(< ?distance ?*DIST_BUSTER*))
	)
	(Gaogaigar_state (follow ?name)
		         
	)
	
	=>
		
	(store Fire 5)
	
		
)

;;************ REGOLE DEI TASK ***************
;;******* FONDAMENTALI PER STRUTTURARE *******
;;****** IL COMPORTAMENTO DI GAOGAIGAR *******
;;********************************************

(defrule in-the-beginning
	(initial-fact)							;;SOLO ALL'INIZIO
	=>
	(assert (task startup))
	
)

(defrule new-turn (declare (salience -100))
	(NewTurn)								;;AD OGNI NUOVO TURNO SI PARTE AD ASSERIRE EVALUATE E POI 
	=>									;;IN SEQUENZA GLI ALTRI FLAG PER COMANDARE LO SWITCH DEI TASK
	(assert (task evaluate))
	(printout t "GAI NEW TURN FOR YA!" crlf)
	(printout t "CHECKING FOR ZONDARS" crlf)
)

(defrule evaluate2think (declare (salience -100))
	?task <- (task evaluate)
	=>
	(retract ?task)
	(assert (task think))
	(printout t "THINK..." crlf)
)

(defrule think2act (declare (salience -100))
	?task <- (task think)
	=>
	(retract ?task)
	(assert (task act))
	(printout t "GO YUUSHA! MIRROR CATAPULT LAUNCHING TOOLS" crlf)
)
(defrule act2end (declare (salience -100))
	?task <- (task act)
	=>
	(retract ?task)
	(assert (task act2))
	(printout t "GOLDION HAMMER SAFETY DEVICE RELEASEEE!" crlf)
)
(defrule act2_2end (declare (salience -100))
	?task <- (task act2)
	=>
	(retract ?task)
	(printout t "UFF! IT'S NOT THE END..." crlf)
)

;;****FUNZIONI PRESE DA ROBERTO TESSERA**********
;;****    STIMA E VENERAZIONE A LUI!   **********
;;***********************************************

(deffunction enemyX(?myX ?distance ?bearing ?myHead)
	(bind ?alpha (+ ?myHead ?bearing))
	(+ ?myX (* ?distance (sin ?alpha)))
)

(deffunction enemyY(?myY ?distance ?bearing ?myHead)		;;CALCOLO DELLA X E DELLA Y DA NOTARE CHE L'ANGOLO SOMMATO SI RIFERISCE AL NORD
	(bind ?alpha (+ ?myHead ?bearing))				;;RISPETTO A CUI SI HA L'HEADING DA NOTARE INFATTI IL SENO PER LA X E IL
	(+ ?myY (* ?distance (cos ?alpha)))				;;COSENO PER LA Y
)

(deffunction predictX(?xOld ?vel ?dir ?timeNow ?timeLast)
	(bind ?dt (- ?timeNow ?timeLast))
	(bind ?dist (* ?dt ?vel))
	(bind ?dx (* ?dist (sin ?dir)))
	(+ ?xOld ?dx)
)

(deffunction predictY(?yOld ?vel ?dir ?timeNow ?timeLast)	;;PREDIZIONE DELLE X E Y SI CALCOLA S = V*T CON T = Tattuale - Tnemico
	(bind ?dt (- ?timeNow ?timeLast))				;;POI SI EFFETTUA UNA TRIANGOLAZIONE SIMILE ALLA PRECEDENTE E SI AGGIORNANO
	(bind ?dist (* ?dt ?vel))					;;X E Y
	(bind ?dy (* ?dist (cos ?dir)))
	(+ ?yOld ?dy)
)

(deffunction distance(?x1 ?y1 ?x2 ?y2)
	(bind ?dx (- ?x1 ?x2))						;;PITAGORA PER LA DISTANZA
	(bind ?dy (- ?y1 ?y2))
	(sqrt (+ (** ?dx 2) (** ?dy 2)))
)

(deffunction normalize(?alpha)
	(bind ?ret ?alpha)
	(if (< ?alpha -180) then (bind ?ret (+ ?alpha 360)))	;;SI NORMALIZZA L'ANGOLO 
	(if (> ?alpha 180) then (bind ?ret (- ?alpha 360))) 
	(bind ?alpha ?ret)
)


